#Data acquisition

    puts "Acquiring data "
    set startacq 0
    set mm [ lindex [ get_service_paths master ] 0 ]
    close_service master $mm
    open_service master $mm

set startacq [master_read_32 $mm 0x4a0000 1]
    set point [master_read_32 $mm 0x4a0014 1 ]
    master_write_32 $mm $point 1

# The following command will configure the driver for AD7606
# Bit 0 controls the Range signal (0 means +-5V, 1 means +-10V)
# Bit 1 controls the StandBy signal. Should be 1 for acquiring data
# Bits [4:2] control the Oversampling signals
# Bits [7:5] configure the number of channels 0 for one channel 7 for 8 channels
# Range
set range 0
# No Oversampling 
set oversampling 0
# Oversampling 2
#set oversampling 1
# Oversampling 4
#set oversampling 2
# Oversampling 8
#set oversampling 3
# Oversampling 16
#set oversampling 4
# Oversampling 32
#set oversampling 5
# Oversampling 64
#set oversampling 6
# Select the number of channels  (between 1 and 8)
set channels 1
if { $channels == 0 } {
    set channels 1
}
if { $channels > 8 } {
    set channels 8
}
# compose command
    set command [expr 2 + [expr $oversampling * 4] + [expr  [expr $channels - 1 ] * 32 ] + $range ]
    puts "Acquisition has been started..."
    master_write_32 $mm 0x4a0018 $command

    while {$startacq == 0} {
        set startacq [master_read_32 $mm 0x4a0000 1]
    }

    puts "Transfer from FPGA to PC has been started..."

    set data [ master_read_memory $mm 0x4e0000 [expr 131072 * $channels ] ]

    master_write_32 $mm 0x4a0004 1

    puts "Converting acquired data to 16 bit values"

    for { set i 0 } { $i < [ llength $data ] } { incr i 2} {
        set a [ lindex $data $i ]
        set b [ lindex $data [expr $i + 1 ] ]
        lappend newData [ expr  { ( $b << 8 ) + $a } ]
        }

    puts "Processing data as two's complement"
    set final " "
    for { set i 0 } { $i < [ llength $newData ] } { incr i $channels} {
        set a [ lindex $newData $i ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
           set decimal [expr $decimal - 65535 ]
        }
        if { $channels == 1} {
            lappend final [expr $decimal ]\n
            continue
        }
        lappend final [expr $decimal ],
        set a [ lindex $newData [expr $i + 1] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        if { $channels == 2} {
            lappend final [expr $decimal ]\n
            continue
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData [expr $i + 2] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        if { $channels == 3} {
            lappend final [expr $decimal ]\n
            continue
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData  [expr $i + 3] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        if { $channels == 4} {
            lappend final [expr $decimal ]\n
            continue
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData [expr $i + 4] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        if { $channels == 5} {
            lappend final [expr $decimal ]\n
            continue
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData [expr $i + 5] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        if { $channels == 6} {
            lappend final [expr $decimal ]\n
            continue
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData [expr $i + 6] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        if { $channels == 7} {
            lappend final [expr $decimal ]\n
            continue
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData [expr $i + 7] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        lappend final [expr $decimal ]\n
        }

    unset data
    unset newData

    master_write_32 $mm 0x4a0008 1

    puts "Moving data into file Acquisition.csv"

    set fd [ open "Acquisition.csv" "a+" ]
    #fconfigure $fd -translation binary
    puts -nonewline $fd [ join $final ]
    close $fd
    master_write_32 $mm 0x4a000C 1
    unset final
    puts "Iteration complete"
    close_service master $mm
