// Copyright (C) 1991-2011 Altera Corporation
// Your use of Altera Corporation's design tools, logic functions
// and other software and tools, and its AMPP partner logic
// functions, and any output files from any of the foregoing
// (including device programming or simulation files), and any
// associated documentation or information are expressly subject
// to the terms and conditions of the Altera Program License
// Subscription Agreement, Altera MegaCore Function License
// Agreement, or other applicable license agreement, including,
// without limitation, that your use is for the sole purpose of
// programming logic devices manufactured by Altera and sold by
// Altera or its authorized distributors.  Please refer to the
// applicable agreement for further details.

// *****************************************************************************
// This file contains a Verilog test bench template that is freely editable to
// suit user's needs .Comments are provided in each section to help the user
// fill out necessary details.
// *****************************************************************************
// Generated on "11/22/2011 16:09:29"

// Verilog Test Bench template for design : AD7606
//
// Simulation tool : ModelSim-Altera (Verilog)
//

`timescale 1 ns / 100 ps
module AD7606_vlg_tst();
// test vector input registers
reg adc_busy_i;
reg [15:0] adc_db_i;
reg [11:0] data_i;
reg fpga_clk_i;
reg reset_n_i;
reg wr_data_n_i;
// wires
wire adc_range_o;
wire adc_cs_n_o;
wire adc_rd_n_o;
wire adc_reset_o;
wire adc_stdby_o;
wire adc_convst_o;
wire [15:0]  data_o;
wire data_rd_ready_o;
wire data_wr_ready_o;
wire sync;

// assign statements (if any)

AD7606 i1 (
// port map - connection between master ports and signals/registers
    .fpga_clk_i(fpga_clk_i),
    .reset_n_i(reset_n_i),

    .wr_data_n_i(wr_data_n_i),

    .data_i(data_i),
    .data_o(data_o),
    .sync_o(sync),
    .data_rd_ready_o(data_rd_ready_o),
    .data_wr_ready_o(data_wr_ready_o),

    .adc_db_i(adc_db_i),
    .adc_busy_i(adc_busy_i),
    .adc_range_o(adc_range_o),
    .adc_cs_n_o(adc_cs_n_o),
    .adc_rd_n_o(adc_rd_n_o),
    .adc_reset_o(adc_reset_o),
    .adc_convst_o(adc_convst_o),
    .adc_stdby_o(adc_stdby_o)
);
initial
begin
    adc_db_i        = 16'h0;
    fpga_clk_i      = 1'b0;
    reset_n_i       = 0;
    adc_busy_i      = 0;
    wr_data_n_i     = 1;
    data_i          = 16'h0;
#100
    reset_n_i   = 1;
#100
    data_i      = 16'h0012;
    wr_data_n_i = 1'b0;
    wait( data_wr_ready_o)
    begin
        wr_data_n_i = 1'b1;
    end
$display("Running testbench");
end


//main clock generation
always
begin
    #10 fpga_clk_i <= ~fpga_clk_i;
end

//simulate ADC behaviour
//generate busy signal
always @(posedge adc_convst_o)
begin
    #40
    adc_busy_i = 1'b1;
    #4110
    adc_busy_i = 1'b0;
end

//generate data
always @(negedge adc_rd_n_o)
begin
    if(adc_cs_n_o == 1'b0)
    begin
        adc_db_i <= adc_db_i + 1;
    end
end
endmodule

